local bar = CreateFrame('StatusBar', 'WitheredBar', UIParent)
bar:SetClampedToScreen(true)
bar:SetMovable(true)
bar:SetUserPlaced(true)
local IsMoving = false
bar:SetScript('OnMouseDown', function(self)
	if IsShiftKeyDown() then
		IsMoving = true
		self:StartMoving()
	end
end)
bar:SetScript('OnMouseUp', function(self)
	self:StopMovingOrSizing()
	IsMoving = false
	if not IsShiftKeyDown() then
		self:EnableMouse(false)
	end
end)
bar:EnableMouse(false)

bar:SetWidth(114)
bar:SetHeight(10)
bar:SetClampRectInsets(-4, 4, 3, -3)
bar:SetPoint('CENTER', 100, 100)
bar:SetBackdrop({bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]]})
bar:SetStatusBarTexture([[Interface\TARGETINGFRAME\UI-StatusBar]], 'ARTWORK')
bar:SetOrientation('HORIZONTAL')
bar:SetBackdropColor(144/255, 47/255, 223/255, 0.6)


local text = bar:CreateFontString(nil, 'OVERLAY')
text:SetFont('Fonts\\FRIZQT__.ttf', 12, "THINOUTLINE")
text:SetPoint('RIGHT', bar, 'RIGHT', -2, 0)
text:SetTextColor(1, 1, 1)
text:SetShadowOffset(1, -1)
bar.text = text

local fill = bar:GetStatusBarTexture()
local spark = bar:CreateTexture(nil, 'ARTWORK', nil, 3)
spark:SetTexture([[Interface\CastingBar\UI-CastingBar-Spark]])
spark:SetBlendMode('ADD')
spark:SetPoint('CENTER', fill, 'RIGHT')
spark:SetSize(8, 24)

local overlay = CreateFrame('frame', nil, bar)
overlay:SetAllPoints()

local border = overlay:CreateTexture(nil, 'OVERLAY', nil, 2)
border:SetPoint('CENTER')
border:SetWidth(bar:GetWidth()+8)
border:SetHeight(bar:GetHeight()+8)
border:SetTexture([[Interface\Tooltips\UI-StatusBar-Border]])
bar.border = border

bar:SetMinMaxValues(0, 100)
bar:SetStatusBarColor(0,0.6,0)

bar:SetValue(100)

bar:Hide()

bar:SetScript('OnEvent', function(self, event, ...)
	if event == 'MODIFIER_STATE_CHANGED' then
		local button, down = ...
		if not IsMoving then
			self:EnableMouse(button == 'LSHIFT' and down == 1)
		end
	else
		local doShow = false
		for i = 1, 40 do
			local spellID, _, _, _, _, _, healthPct, witheredCount = select(11, UnitBuff('player', i))
			if not spellID then
				break
			elseif spellID == 227261 then
				self.text:SetText('x' .. witheredCount)
				self:SetValue(healthPct)
				doShow = true
			end
		end
		self:SetShown(doShow)
	end
end)
bar:RegisterUnitEvent('UNIT_AURA', 'player')
bar:RegisterEvent('MODIFIER_STATE_CHANGED')